routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('home.index');

Route::get('login/{driver}', 'Auth\LoginController@redirectToProvider')->name('login.provider');
Route::get('login/{driver}/callback', 'Auth\LoginController@handleProviderCallback')->name('login.provider_callback');
Auth::routes();

// admin page

Route::prefix('/admin')->group(function(){
	
	// admin dashboard
	Route::get('/', function(){
		return redirect()->route('dashboard');
	});

	Route::get('/dashboard', function(){
		return view('backend.pages.dashboard');
	})->name('dashboard')->middleware(['auth', 'role:admin']);


	// media
	Route::prefix('media')->group(function(){
		Route::post('uploads', 'MediaController@uploads')->name('media.uploads');
		Route::get('get_data', 'MediaController@getData')->name('media.get_data');
		Route::get('select_data/{id}', 'MediaController@selectData')->name('media.get_data');
	});

	Route::resource('/media', 'MediaController');

	// product
	Route::get('/product/get_data', 'ProductController@getData')->name('product.get_data');
	Route::resource('/product', 'ProductController');

	// category
	Route::get('/category/get_category', 'CategoryController@getCategory');
	Route::get('/category/get_parent', 'CategoryController@getParent');
	Route::resource('/category', 'CategoryController');

	// tags
	Route::resource('/tag', 'TagController');

	// order
	Route::get('/order/get_data', 'OrderController@getData')->name('order.get_data');
	Route::resource('/order', 'OrderController');

	// coupon
	Route::get('/coupon/get_data', 'CouponController@getData')->name('coupon.get_data');
	Route::resource('/coupon', 'CouponController');

	// comments
	Route::get('/review/get_data', 'CommentController@getData')->name('comment.get_data');
	Route::resource('/review', 'CommentController');

	// menu
	Route::get('/menu/get_data', 'MenuController@getData')->name('menu.get_data');
	Route::post('/menu/bulk_edit', 'MenuController@bulkEdit')->name('menu.bulk_edit');
	Route::get('/menu/get_menu', 'MenuController@getMenu')->name('menu.get_menu');
	Route::resource('/menu', 'MenuController');

	// user
	Route::post('/user/upload', 'UserController@upload');
	Route::resource('/user', 'UserController');

	// role
	Route::resource('/role', 'RoleController');

	// permission
	Route::resource('/permission', 'PermissionController');

	// widget
	Route::resource('/widget', 'WidgetController');


});

// Route::get('/home', 'HomeController@index')->name('home');

// cart
Route::post('/cart/bulk_update', 'CartController@bulkUpdate')->name('cart.bulk_update');
Route::get('/cart/remove/{hash}', 'CartController@remove')->name('cart.remove');
Route::get('/cart/coupon', 'CartController@coupon')->name('cart.coupon');
Route::resource('/cart', 'CartController');

// currency
Route::get('currency/{type}', 'CurrencyController@set');

// shop
Route::resource('/shop', 'ShopController');

// review

Route::resource('/review', 'ReviewController');

// shipping
Route::post('/shipping/get_services', 'ShippingController@getServices')->name('shipping.get_shipping');
Route::resource('/shipping', 'ShippingController');

// checkout
Route::get('/checkout/status', 'CheckoutController@status')->name('checkout.status');
Route::get('/checkout/payment', 'CheckoutController@payment')->name('checkout.payment');
Route::resource('/checkout', 'CheckoutController');

// user memeber
Route::get('/user', function(){
	return redirect()->route('user.dashboard');
});

Route::get('/dashboard', function(){
	return redirect()->route('user.dashboard');
});

Route::prefix('/user')->group(function(){
	Route::get('/dashboard', 'MemberController@dashboard')->name('user.dashboard');
	Route::get('/order', 'MemberController@order')->name('user.order');
	Route::get('/wishlist', 'MemberController@wishlist')->name('user.wishlist');
	Route::get('/reviews', 'MemberController@reviews')->name('user.reviews');
	Route::put('/profile/{id}', 'MemberController@profileUpdate')->name('user.profile_update');
	Route::get('/profile', 'MemberController@profile')->name('user.profile');
	Route::get('/settings', 'MemberController@settings')->name('user.settings');
	Route::post('/settings/change_password', 'MemberController@changePassword')->name('user.change_password');
	Route::get('/settings/otp', 'MemberController@otp')->name('user.otp');
	Route::post('/settings/otp_submit', 'MemberController@otpSubmit')->name('user.otp_submit');
	Route::get('/settings/test', 'MemberController@test')->name('user.test');
});

Route::get('/api_test', 'ApiController@index');
Route::get('/api_test/notification', 'ApiController@notification');
Route::get('/api_test/send_message', 'ApiController@sendMessage');
Route::get('/api_test/helio', 'ApiController@helio');

// product details
Route::get('/{slug}', 'ShopController@details')->name('shop.details');

app/Media.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class Media extends Model
{
    protected $table = 'tb_m_medias';

    public function getCreatedAtAttribute($value)
    {
    	return Carbon::parse($value)->format('M j Y');
    }
}

app/Order.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Order extends Model
{
    protected $table = 'tb_m_orders';

    public function user()
    {
    	return $this->belongsTo('App\User', 'user_id');
    }

    public function details()
    {
    	return $this->hasMany('App\OrderDetails', 'order_id');
    }

    public function shipping()
    {
    	return $this->hasOne('App\Shipping', 'order_id');
    }

}

app/UserData.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class UserData extends Model
{
    protected $table = 'tb_m_user_datas';
    protected $fillable = ['first_name', 'last_name', 'identity_number', 'phone_number', 'country_id',
    						'province_id', 'city_id', 'sex', 'zip', 'place_of_birth', 'date_of_birth',
							'address', 'picture', 'user_id'];

	public function getFullnameAttribute()
    {
       return "{$this->first_name} {$this->last_name}";
    }
}

app/Http/Controllers/OrderController.php
<?php

/*
@author: Ыулианто
@created at: 2017-11-22
*/

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use DataTables;
use App\Order;
use Carbon\Carbon;
use Helper;
use App\Shipping;
use DB;
use GuzzleHttp\Client;

class OrderController extends Controller
{

    private $api_token;

    public function __construct()
    {
        $this->middleware(['auth', 'role:admin']);

        $client = new Client;
        $headers['Authorization'] = 'Basic OEJ6UkV1OFgxV20yRk9OZjlrMm1ScjdZbjRZYTppdUpLVzlKWXl2UHhyOEdsQkdHcncxcG1TS1lh';
        $headers['Content-Type'] = 'application/x-www-form-urlencoded';

        $body['grant_type'] = 'client_credentials';

        $res = $client->post(
                'https://api.mainapi.net/token', ['headers' => $headers, 'form_params' => $body]
            );

        $contents = $res->getBody()->getContents();
        $this->api_token = json_decode($contents)->access_token;

    }
    
    public function index()
    {
    	return view('backend.pages.order.index');
    }

    public function show($id)
    {
    	$order = Order::find($id);

    	$data = [
    				'order' => $order
    			];

    	return view('backend.pages.order.show')
    			->with($data);

    }

    public function getData(Request $request)
    {
    	$order = Order::with(['user', 'user.user_data'])
    				->get();

    	return DataTables::of($order)

    	->rawColumns(['options', 'status'])

    	->addColumn('status', function($data){

    		/*
			0 : In Proccess
			1 : Challange
			2 : Success
			3 : Fraud
    		*/

			$status = Helper::getStatusTransaction($data->status);

			return $status;


    	})

    	->addColumn('created_at', function($data){

    		return Carbon::parse($data->created_at)->format('F jS, Y h:i A');

    	})

    	->addColumn('options', function($data){
    		return '<a class="btn btn-primary btn-xs" href="'.route('order.show', $data->id).'">View</a>';
    	})

        ->addColumn('total', function($data){
            return Helper::currency($data->total);
        })

    	->make(true);
    }

    public function update($id, Request $request)
    {

        DB::transaction(function() use($id, $request){

            $order = Order::find($id);

            if ($request->status == 2) {

                $client = new Client;

                $headers['Authorization'] = 'Bearer '.$this->api_token;
                $headers['Content-Type'] = 'application/x-www-form-urlencoded';
                $headers['Accept'] = 'application/json';

                $body['msisdn'] = $order->user->user_data->phone_number;
                $body['content'] = 'Your order was complete, with receipt number '.$request->receipt_number.' Thanks, for trusting us';

                $res = $client->post(
                        'https://api.mainapi.net/smsnotification/1.0.0/messages',
                        ['headers' => $headers, 'form_params' => $body]
                    );
            }

            $order->status = $request->status;
            $order->shipping()->update(['receipt_number' => $request->receipt_number]);
            $order->save();

        });

        return redirect()
                ->back()
                ->with('message', 'Order was updated');
    }
}

resources/views/backend/pages/order/index.blade.php
@extends('backend.layouts.master')
@section('title')
Order
@endsection
@section('content')

<div class="section-heading">
	<h1 class="page-title">Order</h1>
</div>


<div class="row">
	<div class="col-md-12">
		<div class="panel-content">
			<table class="table table-primary table-bordered" id="table-order">
				<thead>
					<tr>
						<th>#</th>
						<th>Name</th>
						<th>Date & Time</th>
						<th>Payment Method</th>
						<th>Status</th>
						<th>Total Order</th>
						<th>Option</th>
					</tr>
				</thead>
			</table>
		</div>
	</div>
</div>

@endsection

@push('js')
<script src="{{ url('assets/backend/pages/js/order.js') }}"></script>
@endpush

resources/views/backend/pages/order/show.blade.php
@extends('backend.layouts.master')
@section('title')
#{{ $order->order_number }}
@endsection
@section('content')

<div class="section-heading">
	<h1 class="page-title">#{{ $order->order_number }}</h1>
	<div class="pull-right">
		@if ($order->status == 0)
		<button class="btn btn-primary" id="btn-update">Update Status</button>
		@endif
		<a href="{{ route('order.index') }}" class="btn btn-primary">Back</a>
	</div>
</div>


<div class="row">
	<div class="col-md-12">
		<div class="panel-content">	
			@if (session()->has('message'))
				<div class="alert alert-success alert-dismissible" role="alert">
				  <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
				  <strong>Well Done!</strong> {{ session()->get('message') }}
				</div>
			@endif
			<div class="row">
				<div class="col-md-4">
					<strong>Order Number</strong>
					<h3 class="text-muted">#{{ $order->order_number }}</h3>
				</div>

				<div class="col-md-4">
					<strong>Amount</strong>	
					<h3 class="text-muted">{{ Helper::currency($order->total) }}</h3>
				</div>

				<div class="col-md-4">
					<strong>Payment Method</strong>
					<h3 class="text-muted">{{ $order->payment_method }}</h3>
				</div>

			</div>

			<div class="row">
				<div class="col-md-12">
					<hr>
					<table class="table table-primary table-custom">
						<thead>
							<tr class="alert-success">
								<td colspan="2">Order Details</td>
								<td colspan="2">Customer Information</td>
							</tr>
							<tr>
								<td><strong>Order Number</strong></td>
								<td>{{ $order->order_number }}</td>

								<td><strong>Name</strong></td>
								<td>{{ $order->user->user_data->fullname }}</td>
							</tr>
							<tr>
								<td><strong>Payment Method</strong></td>
								<td>{{ $order->payment_method }}</td>

								<td><strong>Phone Number</strong></td>
								<td>{{ $order->user->user_data->phone_number }}</td>
							</tr>
							<tr>
								<td><strong>Transaction Date</strong></td>
								<td>{{ Carbon\Carbon::parse($order->created_at)->format('F jS, Y h:i A') }}</td>

								<td><strong>Email</strong></td>
								<td>{{ $order->user->email }}</td>
							</tr>
							<tr>
								<td><strong>Transaction Status</strong></td>
								<td>{!! Helper::getStatusTransaction($order->status) !!}</td>

								<td><strong>Address</strong></td>
								<td>
									{{ $order->user->user_data->address }}, {{ $order->user->user_data->zip }}
									<br>
									{{ Helper::getProvince($order->user->user_data->province_id) }}
									<br>
									{{ Helper::getCity($order->user->user_data->city_id) }}
									<br>
									{{ $order->user->user_data->country_id }}
								</td>
							</tr>

						</thead>
					</table>
				</div>

				<div class="col-md-12">
					
					<table class="table table-primary table-custom">
						<thead>
							<tr class="alert-info">
								<td colspan="4">Shipping Info #{{ $order->shipping->receipt_number }}</td>
							</tr>
							<tr>
								<td><strong>Shipping To</strong></td>
								<td>{{ $order->shipping->first_name.' '.$order->shipping->last_name }}</td>
								<td><strong>Shipping Phone Number</strong></td>
								<td>
									{{ $order->shipping->phone_number }}
								</td>
							</tr>
							<tr>
								<td><strong>Shipping Address</strong></td>
								<td>
									{{ $order->shipping->address }}
			                        <br>
			                        {{ Helper::getCity($order->shipping->city_id) }}
			                        <br>
			                        {{ Helper::getProvince($order->shipping->province_id) }}
			                        <br>
			                        {{ $order->shipping->country_id }}
			                        <br>
								</td>
								<td><strong>Courier Details</strong></td>
								<td>
									{{ strtoupper($order->shipping->courier_id) }}
			                        <br>
		                         	{{ $order->shipping->service_name }} ({{ $order->shipping->service_description }})
			                        <br>
			                        {{ $order->shipping->estimate_delivery }} (Days)
								</td>
							</tr>
						</thead>
					</table>
						
				</div>

				<div class="col-md-12">
					<h3 class="heading">Transaction Details</h3>
					<table class="table table-primary table-bordered">
						<thead class="alert-info">
							<tr>
								<th>Product Name</th>
								<th class="text-right">Price</th>
								<th class="text-center">Qty</th>
								<th class="text-right">Coupon</th>
								<th>Attributes</th>
								<th class="text-right">Total</th>
							</tr>
						</thead>
						<tbody>
							@foreach ($order->details as $data_details)
							<tr>
								<td>{{ $data_details->product->name }}</td>
								<td class="text-right">{{ Helper::currency($data_details->price) }}</td>
								<td class="text-center">{{ $data_details->qty }}</td>
								<td class="text-right">{{ $data_details->coupon_id }}</td>
								<td>

									@foreach ($data_details->attributes as $attribute)

										{{ $attribute->attribute_name }} : {{ $attribute->attribute_value }} <br>

									@endforeach

								</td>
								<td class="text-right">{{ Helper::currency($data_details->total) }}</td>
							</tr>
							@endforeach
						</tbody>
						<tfoot>
							<tr>
								<th colspan="5" class="text-right">Sub Total</th>
								<th class="text-right">{{ Helper::currency($order->sub_total) }}</th>
							</tr>
							<tr>
								<th colspan="5" class="text-right">Tax</th>
								<th class="text-right">{{ Helper::currency($order->tax) }}</th>
							</tr>
							<tr>
								<th colspan="5" class="text-right">Shipping Fee</th>
								<th class="text-right">{{ Helper::currency($order->shipping->cost) }}</th>
							</tr>
							<tr>
								<th colspan="5" class="text-right">Total</th>
								<th class="text-right">{{ Helper::currency($order->total) }}</th>
							</tr>
						</tfoot>
					</table>
				</div>

			</div>
			
		</div>
	</div>
</div>

<form action="{{ route('order.update', $order->id) }}" method="post">
	{{ csrf_field() }}
	{{ method_field('PUT') }}
	<div class="modal fade" tabindex="-1" role="dialog" id="modal-update">
	  <div class="modal-dialog" role="document">
	    <div class="modal-content">
	      <div class="modal-header">
	        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
	        <h4 class="modal-title">Update Status</h4>
	      </div>
	      <div class="modal-body">
	        <div class="row">
	        	<div class="col-md-12">
	        		<div class="form-group">
	        			<label class="control-label">Status</label>
	        			<select name="status" class="select2" data-placeholder="Change Status">
	        				<option></option>
	        				<option value="1">Challange</option>
	        				<option value="2">Success</option>
	        				<option value="3">Fraud</option>
	        			</select>
	        		</div>
	        		<div class="form-group">
	        			<label class="control-label">Receipt Number</label>
	        			<input type="text" name="receipt_number" class="form-control" placeholder="Courier Receipt Number">
	        		</div>
	        	</div>
	        </div>
	      </div>
	      <div class="modal-footer">
	        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
	        <button type="submit" class="btn btn-primary">Save changes</button>
	      </div>
	    </div><!-- /.modal-content -->
	  </div><!-- /.modal-dialog -->
	</div><!-- /.modal -->
</form>

@endsection

@push('js')
<script src="{{ url('assets/backend/pages/js/order-show.js') }}"></script>
@endpush